var documenterSearchIndex = {"docs":
[{"location":"#Horse-Manual","page":"Horse Manual","title":"Horse Manual","text":"","category":"section"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Horse provides an easy-to-use machine learning library ","category":"page"},{"location":"#Installation","page":"Horse Manual","title":"Installation","text":"","category":"section"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Horse can be installed using the Julia package manager. From the Julia REPL, type ] to enter the Pkg REPL mode and run However, it can't be installed by name.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"pkg > https://github.com/QGMW22/Horse/Horse.jl","category":"page"},{"location":"#How-to-use","page":"Horse Manual","title":"How to use","text":"","category":"section"},{"location":"#How-to-use-SGD","page":"Horse Manual","title":"How to use SGD","text":"","category":"section"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Stochastic Gradient Descent(SGD) can be used as follows.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"using Horse\nx = [15.43 23.01 5.0 12.56 8.67 7.31 9.66 13.64 14.92 18.47 15.48 22.1 26.95 5.68 21.76]\nt = [170.91 160.68 129.0 159.7 155.46 140.56 153.65 159.43 164.7 169.71 173.29 159.31 171.52 138.96 165.87]\nw = Linear_Regression.SGD.fit(x, t)\nprintln(w) #[1.539947 136.176160] The first element is tilted and the second element is the intercept.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The arguments are as follows. However, other than x and t, they are keyword arguments. The values ​​in parentheses are the default values.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"LinearRegression.SGD.fit(x=[Dependent variable], t = [Objective variable], alpha = (0.001)[Learning rate], taumax = (100000)[Maximum number of iterations], eps = (0.1)[Absolute threshold of gradient to stop repeating])","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The return value is an Array type.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Prediction using the built model can be done with the following function. However, x and w are not keyword arguments.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Linear_Regression.SGD.predict(x = [Dependent variable], w = [Array of w obtained by fitting])","category":"page"},{"location":"#How-to-use-multiple-regression","page":"Horse Manual","title":"How to use multiple regression","text":"","category":"section"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Multiple regression can be used as follows.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"using Horse\nx =[15.43 23.01 5.0 12.56 8.67 7.31 9.66 13.64 14.92 18.47 15.48 22.13 10.11 26.95 5.68 21.76; 70.43 58.15 37.22 56.51 57.32 40.84 57.79 56.94 63.03 65.69 62.33 64.95 57.73 66.89 46.68 61.08]\nt = [170.91 160.68 129.0 159.7 155.46 140.56 153.65 159.43 164.7 169.65 160.71 173.29 159.31 171.52 138.96 165.87]\nw = Linear_Regression.MR.fit(x, t) #Here, because there is no inverse matrix, I get an error.\nprintln(w)","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"In multiple regression, if the inverse matrix cannot be generated in the program, the following error is returned.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Perhaps the matrix x you passed does not have an inverse matrix. In that case, use ridge regression.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"As shown in the error statement, regression can be performed by using ridge regression or lasso regression, but the eigenvalue is close to 0, which makes the model unstable. Therefore, it is one way to perform processing such as deleting a row of highly correlated data.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The arguments are as follows. However, x and t are not keyword arguments.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Linear_Regression.MR.fit(x = [Dependent variable], t = [Objective variable])","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The return value is an Array type, the first element is the intercept of the model, and the subsequent elements are the coefficients of each dependent variable.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Prediction using the built model can be done with the following function. However, x and w are not keyword arguments.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Linear_Regression.MR.predict(x = [Dependent variable], w = [Array of w obtained by fitting])","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The return value is an Array type.","category":"page"},{"location":"#How-to-use-Ridge-Regression","page":"Horse Manual","title":"How to use Ridge Regression","text":"","category":"section"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Ridge regression can be used as follows.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"using Horse\nx =[15.43 23.01 5.0 12.56 8.67 7.31 9.66 13.64 14.92 18.47 15.48 22.13 10.11 26.95 5.68 21.76; 70.43 58.15 37.22 56.51 57.32 40.84 57.79 56.94 63.03 65.69 62.33 64.95 57.73 66.89 46.68 61.08]\nt = [170.91 160.68 129.0 159.7 155.46 140.56 153.65 159.43 164.7 169.65 160.71 173.29 159.31 171.52 138.96 165.87]\nw = Linear_Regression.RR.fit(x, t)\n#[65.47458454192515; 0.1042034860770639; 1.5756199878279644] The first element represents the intercept and the second and subsequent elements represent the coefficients of the dependent variable.\nprintln(w)","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The arguments are as follows. However, other than x and t, they are keyword arguments. The values ​​in parentheses are the default values.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Linear_Regression.RR.fit(x = [Dependent variable], t = [Objective variable], alpha = (0.1)[learning rate])","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The return value is an Array type, the first element represents the intercept of the model, and the second and subsequent elements represent the coefficients of the dependent variable.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Prediction using the built model can be done with the following function. However, x and w are not keyword arguments.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Linear_Regression.RR.predict(x = [Dependent variable], w = [Array of obtained by fitting])","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The return value is an Array type.","category":"page"},{"location":"#How-to-use-Lasso-Regression","page":"Horse Manual","title":"How to use Lasso Regression","text":"","category":"section"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Lasso regression can be used as follows.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"using Horse\nx =[15.43 23.01 5.0 12.56 8.67 7.31 9.66 13.64 14.92 18.47 15.48 22.13 10.11 26.95 5.68 21.76; 70.43 58.15 37.22 56.51 57.32 40.84 57.79 56.94 63.03 65.69 62.33 64.95 57.73 66.89 46.68 61.08]\nt = [170.91 160.68 129.0 159.7 155.46 140.56 153.65 159.43 164.7 169.65 160.71 173.29 159.31 171.52 138.96 165.87]\nw = Linear_Regression.LR.fit(x, t)\n# [144.61846209854855, 0.951158307335192, 0.0] The first element represents the intercept and the second and subsequent elements represent the coefficients of the dependent variable.\nprintln(w)","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The arguments are as follows. However, other than x and t, they are keyword arguments. The values ​​in parentheses are the default values.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Linear_Regression.LR.fit(x = [Dependent variable], t = [Objective variable], alpha = (0.1)[learning rate], tol = (0.0001)[The absolute value of the error to stop repeating], mi = (1000000)[Maximum number of iterations] )","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The return value is of type Array, the first element represents the intercept of the model, and the second and subsequent elements represent the coefficients of the dependent variable.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Prediction using the built model can be done with the following function. However, x and w are not keyword arguments.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Linear_Regression.LR.predict(x = [Dependent variable], w = [Array of obtained by fitting])","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The return value is of type LinearAlgebra.Adjoint.","category":"page"},{"location":"#How-to-use-MSE(Mean-Square-Error)","page":"Horse Manual","title":"How to use MSE(Mean Square Error)","text":"","category":"section"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"Mean Square Error can be used as follows.","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"using Horse\nmean = Loss_Function.MSE([1, 2, 3, 4], [1, 2, 3, 4], [1, 2])\nprintln(mean) #4","category":"page"},{"location":"","page":"Horse Manual","title":"Horse Manual","text":"The arguments are as follows. However, x, t, w are not keyword arguments. Loss_Function.MSE(x = [従属変数], t = [目的変数], w = [モデル]) The return value is a Float type. In addition, model w is passed so that the first element is the intercept and the second and subsequent elements are the coefficients of the dependent variable.","category":"page"},{"location":"Japanese/#Horse-日本語版マニュアル","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"","category":"section"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Horseは使いやすく、高速な機械学習ライブラリを提供します。現時点では、回帰による学習に限られていますが、これから徐々に拡張していきます。","category":"page"},{"location":"Japanese/#インストール","page":"Horse 日本語版マニュアル","title":"インストール","text":"","category":"section"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Horseは今のところ名前でインストールする事はできません、次のようにする必要があります。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"pkg > add https://github.com/QGMW22/Horse/Horse.jl","category":"page"},{"location":"Japanese/#使い方","page":"Horse 日本語版マニュアル","title":"使い方","text":"","category":"section"},{"location":"Japanese/#SGDの使い方","page":"Horse 日本語版マニュアル","title":"SGDの使い方","text":"","category":"section"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"勾配最急下法（SGD）は以下のようにして使うことができます","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"using Horse\nx = [15.43 23.01 5.0 12.56 8.67 7.31 9.66 13.64 14.92 18.47 15.48 22.1 26.95 5.68 21.76]\nt = [170.91 160.68 129.0 159.7 155.46 140.56 153.65 159.43 164.7 169.71 173.29 159.31 171.52 138.96 165.87]\nw = Linear_Regression.SGD.fit(x, t)\nprintln(w) #[1.539947 136.176160] 一つ目の要素が傾き、二つ目の要素が切片を表す。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"引数は次の通りです。ただし、x, t以外はキーワード引数となっています。（）内はデフォルト値","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"LinearRegression.SGD.fit(x=[従属変数], t = [目的変数], alpha = (0.001)[学習率], taumax = (100000)[繰り返しの最大数], eps = (0.1)[繰り返しをやめる勾配の絶対値の閾値])","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"返り値は、Array型で返されます。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"構築したモデルを使った予測は以下の関数で行えます。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Linear_Regression.SGD.predict(x = [従属変数], w = [フィットして得られたwのArray])","category":"page"},{"location":"Japanese/#重回帰の使い方","page":"Horse 日本語版マニュアル","title":"重回帰の使い方","text":"","category":"section"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"重回帰は以下のようにして使うことができます。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"using Horse\nx =[15.43 23.01 5.0 12.56 8.67 7.31 9.66 13.64 14.92 18.47 15.48 22.13 10.11 26.95 5.68 21.76; 70.43 58.15 37.22 56.51 57.32 40.84 57.79 56.94 63.03 65.69 62.33 64.95 57.73 66.89 46.68 61.08]\nt = [170.91 160.68 129.0 159.7 155.46 140.56 153.65 159.43 164.7 169.65 160.71 173.29 159.31 171.52 138.96 165.87]\nw = Linear_Regression.MR.fit(x, t) #ここでは、逆行列が存在しないため、Errorが出る\nprintln(w)","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"重回帰では、プログラム内で逆行列を生成できなかった場合、以下のようなErrorを返します。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Perhaps the matrix x you passed does not have an inverse matrix. In that case, use ridge regression.","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"エラー文の通りリッジ回帰を使うのも一つの手段ではありますが、いずれにしても固有値が0に近いことは事実であるが故に、不安定なモデルになってしまうため、相関の高いデータを一列残して削除することで解決する等の手段も考ると良いです。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"引数は以下の通りです。ただし、x, tはキーワード引数ではありません。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Linear_Regression.MR.fit(x = [従属変数], t = [目的変数])","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"返り値はArray型で返され、一つ目の要素がモデルの切片、それ以降はそれぞれの従属変数の係数となっています。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"構築したモデルを使った予測は以下の関数で行えます。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Linear_Regression.MR.predict(x = [従属変数], w = [フィットして得られたwのArray])","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"返り値はArray型で返されます。","category":"page"},{"location":"Japanese/#リッジ回帰の使い方","page":"Horse 日本語版マニュアル","title":"リッジ回帰の使い方","text":"","category":"section"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"リッジ回帰は以下のようにして使うことができます。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"using Horse\nx =[15.43 23.01 5.0 12.56 8.67 7.31 9.66 13.64 14.92 18.47 15.48 22.13 10.11 26.95 5.68 21.76; 70.43 58.15 37.22 56.51 57.32 40.84 57.79 56.94 63.03 65.69 62.33 64.95 57.73 66.89 46.68 61.08]\nt = [170.91 160.68 129.0 159.7 155.46 140.56 153.65 159.43 164.7 169.65 160.71 173.29 159.31 171.52 138.96 165.87]\nw = Linear_Regression.RR.fit(x, t)\nprintln(w) #[65.47458454192515; 0.1042034860770639; 1.5756199878279644] 一つ目の要素が切片、二つ以降の要素は従属変数xの係数を表す","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"引数は以下の通りです。ただし、x, tはキーワード引数ではありません。（）内はデフォルト値","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Linear_Regression.RR.fit(x = [従属変数], t = [目的変数], alpha = (0.1)[学習率])","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"戻り値はArray型で返され、一つ目の要素がモデルの切片、二つ目以降の要素は従属変数xの係数を表します。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"構築したモデルを使った予測は以下の関数で行えます。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Linear_Regression.RR.predict(x = [従属変数], w = [フィットして得たwのArray])","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"返り値はArray型で返されます。","category":"page"},{"location":"Japanese/#ラッソ回帰の使い方","page":"Horse 日本語版マニュアル","title":"ラッソ回帰の使い方","text":"","category":"section"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"ラッソ回帰は以下のようにして使うことができます。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"using Horse\nx =[15.43 23.01 5.0 12.56 8.67 7.31 9.66 13.64 14.92 18.47 15.48 22.13 10.11 26.95 5.68 21.76; 70.43 58.15 37.22 56.51 57.32 40.84 57.79 56.94 63.03 65.69 62.33 64.95 57.73 66.89 46.68 61.08]\nt = [170.91 160.68 129.0 159.7 155.46 140.56 153.65 159.43 164.7 169.65 160.71 173.29 159.31 171.52 138.96 165.87]\nw = Linear_Regression.LR.fit(x, t)\nprintln(w) # [144.61846209854855, 0.951158307335192, 0.0] 一つ目の要素が切片、二つ目以降が従属変数xの係数を表す","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"引数は以下の通りです。ただし、x, tはキーワード引数ではありません。（）内はデフォルト値","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Linear_Regression.LR.fit(x = [従属変数], t = [目的変数], alpha = (0.1)[学習率], tol = (0.0001)[繰り返しをやめる誤差の絶対値の闘値], mi = (1000000)[繰り返しの最大数] )","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"戻り値はArray型で返され、一つ目の要素はモデルの切片、二つ目以降が従属変数xの係数を表します。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"構築したモデルを使った予測は以下の関数で行えます。ただし、x, wはキーワード引数ではありません。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"Linear_Regression.LR.predict(x = [従属変数], w = [フィットして得られたwのArray])","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"返り値はLinearAlgebra.Adjoint型で返されます。","category":"page"},{"location":"Japanese/#MSE（平均二乗誤差）の使い方","page":"Horse 日本語版マニュアル","title":"MSE（平均二乗誤差）の使い方","text":"","category":"section"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"平均二乗誤差は以下のようにして使うことができます。","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"using Horse\nmean = Loss_Function.MSE([1, 2, 3, 4], [1, 2, 3, 4], [1, 2])\nprintln(mean) #4","category":"page"},{"location":"Japanese/","page":"Horse 日本語版マニュアル","title":"Horse 日本語版マニュアル","text":"引数は以下の通りです。ただし、x, t, wはキーワード引数ではありません。 Loss_Function.MSE(x = [従属変数], t = [目的変数], w = [モデル]) 返り値はFloat型です。また、モデルwは、一つ目の要素が切片、二つ目以降が従属変数xの係数となるように渡します。","category":"page"}]
}
